# gui.py
# basiert auf Demo_mit_StaticText&TextCtrl_ENTER.py

import wx

from raumplanerModell import RaumplanerModell

### ---------------------------------------------------
class Gui(wx.Frame):
    def __init__(
            self, parent, ID, title, pos=(500,50), # neu
            size=(400,400), style=wx.DEFAULT_FRAME_STYLE
            ):

        wx.Frame.__init__(self, parent, ID, title, pos, size, style)
        self.__modell = None
        panel = wx.Panel(self, -1)

        ### Menu-Abschnitt
        # Prepare the menu bar
        menuBar = wx.MenuBar()

        # erstes Menue
        dateiMenu = wx.Menu()
        dateiMenu.Append(101, "Oeffnen")
        dateiMenu.Append(102, "Speichern")
        dateiMenu.AppendSeparator()
        dateiMenu.Append(103, "Beenden")
        # Add menu to the menu bar
        menuBar.Append(dateiMenu, "Datei")

        # zweites Menue
        neuMenu = wx.Menu()
        neuMenu.Append(201, "Stuhl", "")
        neuMenu.Append(202, "Tisch", "")
        neuMenu.Append(203, "Schrank", "")
        ##neuMenu.AppendSeparator()
        # Add menu to the menu bar
        menuBar.Append(neuMenu, "&Moebel")
        
        self.SetMenuBar(menuBar)

        ### Menu events
        self.Bind(wx.EVT_MENU, self.OnOeffnen, id=101)
        self.Bind(wx.EVT_MENU, self.OnSpeichern, id=102)
        self.Bind(wx.EVT_MENU, self.OnBeenden, id=103) ## Korrektur

        self.Bind(wx.EVT_MENU, self.OnStuhl, id=201)
        self.Bind(wx.EVT_MENU, self.OnTisch, id=202)
        self.Bind(wx.EVT_MENU, self.OnSchrank, id=203)


        gbs = self.gbs = wx.GridBagSizer(vgap=5, hgap=5)

        ### Label und TextCtrl
        self.labelX = wx.StaticText(panel, -1, "x-Position")
        gbs.Add(self.labelX, (0,0), flag=wx.ALL, border=10)
        self.textCtrlX = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlX, (0,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlX)

        self.labelY = wx.StaticText(panel, -1, "y-Position")
        gbs.Add(self.labelY, (1,0), flag=wx.ALL, border=10)
        self.textCtrlY = wx.TextCtrl(panel, -1,
                                     "",
                                     size=(205, -1),
                                     style=wx.TE_PROCESS_ENTER) ## wichtig!!!
        gbs.Add(self.textCtrlY, (1,1), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_TEXT_ENTER, self.OnTextEnter, self.textCtrlY)

        ### Button-Abschnitt
        waehleButton = wx.Button(panel, 1001, u"wähle")
        gbs.Add(waehleButton, (6,0), flag=wx.ALL, border=10)
        self.Bind(wx.EVT_BUTTON, self.OnWaehle, waehleButton)
        
        beendenButton = wx.Button(panel, 1003, "Beenden")
        gbs.Add(beendenButton, (6,1), flag=wx.ALL | wx.ALIGN_RIGHT, border=10)
        self.Bind(wx.EVT_BUTTON, self.OnBeenden, beendenButton)
        ### Fensterereignis
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        panel.SetSizerAndFit(gbs)

    def SetzeModell(self,modell):
        self.__modell = modell

    ### Ereignisbehandlung ###
    ### TextCtrl
    def OnTextEnter(self, event):
        ##print('Enter bei Inhalt "'+self.textCtrl1.GetValue()+'"')
        xT=self.textCtrlX.GetValue() # neu
        yT=self.textCtrlY.GetValue() # neu
        try:
            x=int(xT)
            y=int(yT)
        except ValueError as e:
            return
        self.__modell.SetzeDaten(x,y)

##    def OnText(self, event):                      ## sinnvoll ??
##        inhalt=self.textCtrl1.GetValue() # neu
##        try:
##            self.__modell.Waehle(int(self.textCtrl1.GetValue())-1)  # neu!
##        except ValueError as e:
##            pass
        
    ### Menu-Abschnitt
    def OnOeffnen(self, event):
        ##self.textCtrl1.SetValue('Oeffnen angeklickt')
        self.__modell.Lade('Daten/daten_1.dat')

    def OnSpeichern(self, event):
        ##self.textCtrl1.SetValue('Speichern angeklickt')
        self.__modell.Speichere('Daten/daten_1.dat')

    def OnStuhl(self, event):
        ##self.textCtrl1.SetValue('erzeuge Stuhl angeklickt')
        self.__modell.Neu('Stuhl', sichtbar=True)

    def OnTisch(self, event):
        ##self.textCtrl1.SetValue('erzeuge Tisch angeklickt')
        self.__modell.Neu('Tisch', sichtbar=True)

    def OnSchrank(self, event):
        ##self.textCtrl1.SetValue('erzeuge Schrank angeklickt')
        self.__modell.Neu('Schrank', sichtbar=True)


    ### Button-Abschnitt
    def OnWaehle(self, event):        
        self.__modell.Waehle() # neu
        if self.__modell.HatAusgewaehltes():
            ausgewaehlt=self.__modell.GibAusgewaehltes()
            self.textCtrlX.SetValue(str(ausgewaehlt.GibX()))
            self.textCtrlY.SetValue(str(ausgewaehlt.GibY()))
        ##if ausgewaehlt==-1: ausgewaehlt='keines' # neu
        ##if type(ausgewaehlt)==int: ausgewaehlt+=1 # neu
        ##self.textCtrl1.SetValue(str(ausgewaehlt)) # neu
    
    def OnBeenden(self, event):
        self.Close(True)

    def OnCloseWindow(self, event):
        self.Destroy()

### ---------------------------------------------------
class RaumplanerApp(wx.App):
    """Anwendung fuer Raumplaner"""
    def OnInit(self):
        self.fenster = Gui(None, 1000, "Raumplaner")
        self.SetTopWindow(self.fenster)
        self.fenster.Show(True)
        return True

### ---------------------------------------------------
if __name__ == '__main__':
    app = RaumplanerApp(redirect=False)
    app.MainLoop()
